
import { _decorator, Component, Node, find, instantiate, Label, Prefab, ProgressBar, resources, Sprite } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = Test
 * DateTime = Thu Mar 31 2022 18:59:50 GMT+0800 (中国标准时间)
 * Author = lamd
 * FileBasename = Test.ts
 * FileBasenameNoExtension = Test
 * URL = db://assets/Test.ts
 * ManualUrl = https://docs.cocos.com/creator/3.4/manual/zh/
 *
 */

@ccclass('Test')
export class Test extends Component {
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;

    start() {
        const canvas: Node = find("Canvas");
        const loading = canvas.getChildByName("loading")
        const container = canvas.getChildByName("Container");

        const progressBar = loading.getComponentInChildren(ProgressBar);
        const lbProgress = loading.getChildByName("lbProgress").getComponent(Label)

        const row = 100;
        const col = 100;
        const total = row * col;
        let count = 0;
        for (let y = 0; y < col; y++) {
            for (let x = 0; x < row; x++) {
                resources.load("pfbTile", Prefab, (err, prefab) => {
                    const tileNode = instantiate(prefab);
                    container.addChild(tileNode);

                    // 进度
                    count++;
                    const progresValue = Math.floor(count / total * 100);
                    lbProgress.string = progresValue.toString() + "%";
                    progressBar.progress = progresValue/100;

                    if (count == total) {
                        loading.active = false;
                        console.log("loaded all ....... ");
                    }
                });
            }
        }
    }

    // update (deltaTime: number) {
    //     // [4]
    // }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.4/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.4/manual/zh/scripting/decorator.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.4/manual/zh/scripting/life-cycle-callbacks.html
 */
